#include "AneuMeshLoader.h"

void AneuMeshLoader::loadMesh(const std::string& a_filename)
{
	int count, N;
	std::ifstream file(a_filename);
	if (!file)
	{
		
	}
	else
	{

	}

	file >> count >> N;
	Node temp;
	m_Nodes.reserve(count);
	for (int i: std::ranges::iota_view(0, count))
	{
        // ЭТА ПЕРЕМЕННАЯ СОЗДАЁТСЯ И УНИЧТОЖАЕТСЯ НА КАЖДОЙ ИТЕРАЦИИ ЦИКЛА -
        // ЛИШНЯЯ РАБОТА, ЛУЧШЕ ВЫНЕСТИ ЕЁ ОПРЕДЕЛЕНИЕ ЗА ЦИКЛ
		temp.m_id = i;
		file >> temp.x >> temp.y >> temp.z;
		temp.m_flag = true;
        // РАЗМЕР ВЕКТОРА ИЗВЕСТЕН ЗАРАНЕЕ, ПОЭТОМУ НАДО ВОСПОЛЬЗОВАТЬСЯ
        // ФУНКЦИЕЙ vector::reserve, ЧТОБЫ push_back НЕ ЗАНИМАЛСЯ
        // РАСШИРЕНИЕМ ДОСТУПНОЙ ДЛЯ ВЕКТОРА ПАМЯТИ И ЛИШНИМ КОПИРОВАНИЕМ
        // https://en.cppreference.com/w/cpp/container/vector/reserve
		m_Nodes.push_back(temp);
	}

	file >> count >> N;
	for (int i : std::ranges::iota_view(0, count))
	{
		FiniteElement temp;
		temp.m_id = i;
		file >> temp.m_material_id;

		int iNodeId;
		for (int j : std::ranges::iota_view(0, N))
		{
			file >> iNodeId;
			temp.m_nodes_id.push_back(iNodeId);
		}
		m_FiniteElements.push_back(std::move(temp));
	}

	file >> count >> N;
	for (int i : std::ranges::iota_view(0, count))
	{
		BoundaryFiniteElement temp;
		temp.m_id = i;
		file >> temp.m_boundary_id;

		int iNodeId;
		for (int j : std::ranges::iota_view(0, N))
		{
			file >> iNodeId;
			temp.m_surface_elems_id.push_back(iNodeId);
		}
		m_BoundaryFiniteElements.push_back(std::move(temp));

	}
	file.close();
}
