#pragma once
#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <ranges>
#include <unordered_set>
#include "Structures.h"

class MeshLoader
{
protected:

	std::vector<Node> m_Nodes;
	std::vector<FiniteElement> m_FiniteElements;
	std::vector<BoundaryFiniteElement> m_BoundaryFiniteElements;

public:

	virtual void loadMesh(const std::string& a_filename) = 0;
	virtual ~MeshLoader() = default;

	std::vector<Node>& getNodes();
	std::vector<FiniteElement>& getFiniteElements();
	std::vector<BoundaryFiniteElement>& getBoundaryFiniteElements();

	std::vector<FiniteElement> findFiniteElementsByNodesID(int a_id1, int a_id2, int a_id3);
	std::vector<FiniteElement> findFiniteElementsByNodesID(int a_id1, int a_id2);

	std::set<int> getSurfaceNodesByID(int a_id);
	std::vector<FiniteElement> getFiniteElementsByID(int a_id);
	std::vector<BoundaryFiniteElement> getBoundaryFiniteElementsByID(int a_id);

	void insertNewNode();
	std::vector<std::set<int>> getNeighborElements();
};