#include "AneuMeshLoader.h"

int main()
{
    // УМНЫЙ УКАЗАТЕЛЬ ИСПОЛЬЗУЙ
    std::unique_ptr<MeshLoader> p_aneuML = new AneuMeshLoader;
    std::string filename;
    std::cout << "Enter filename:" << std::endl;
    std::cin >> filename;
    p_aneuML->loadMesh(filename);

    bool flag = true;
    while (flag) 
    {
        std::cout << "1.  Print Nodes"                      << std::endl;
        std::cout << "2.  Print Finite Elements"            << std::endl;
        std::cout << "3.  Print Boundary finite elements"   << std::endl;

        std::cout << "4.  Find Finite elements by Nodes ID" << std::endl;
        std::cout << "5.  Find Finite elements by 3 ID"     << std::endl;

        std::cout << "6.  Surface nodes by 2 ID"            << std::endl;
        std::cout << "7.  Finite elements by material id"   << std::endl;
        std::cout << "8.  Boundary finite elements by id"   << std::endl;

        std::cout << "9. Insert new node"                   << std::endl;
        std::cout << "10. Neighboor elements"               << std::endl;

        std::cout << "11. Exit"                             << std::endl;

        int select;
        std::cin >> select;
        switch (select) 
        {
            case 1: 
                for (auto i : p_aneuML->getNodes())
                {
                  std::cout << i << std::endl;
                }
            break;
            case 2: 
                for (auto i : p_aneuML->getFiniteElements())
                {
                    std::cout << i << std::endl;
                }
                break;
            case 3: 
                for (auto i : p_aneuML->getBoundaryFiniteElements())
                {
                    std::cout << i << std::endl;
                }
                break;
            case 4: 
                for (auto i : p_aneuML->findFiniteElementsByNodesID(1,2,3))
                {
                    std::cout << i << std::endl;
                }
                break;
            case 5: 
                for (auto i : p_aneuML->findFiniteElementsByNodesID(1,2))
                {
                    std::cout << i << std::endl;
                }
                break;
            case 6: 
                for (auto i : p_aneuML->getSurfaceNodesByID(1))
                {
                    std::cout << i << std::endl;
                }
                break;
            case 7: 
                for (auto i : p_aneuML->getFiniteElementsByID(1))
                {
                    std::cout << i << std::endl;
                }
                break;
            case 8: 
                for (auto i : p_aneuML->getBoundaryFiniteElementsByID(1))
                {
                    std::cout << i << std::endl;
                }
                break;
            case 9:
                p_aneuML->insertNewNode();
                break;
            case 10: 
                for (auto i : p_aneuML->getNeighborElements())
                {
                    for (auto j : i)
                    {
                        std::cout << j << " ";
                    }
                    std::cout << std::endl;
                }
                break;
            case 11: 
                flag = false; 
                break;
            default: 
                std::cout << "Error, try again" << std::endl;
        }
    }

    delete p_aneuML;
    return 0;
}
